var FS = {
    root:null,
    getFileCB:null,
    applicationRoot:"data/data/HESEA/",
    httpErrors:{
        0:"Device is not connected to the Internet",
        403:"Access Forbidden",
        404:'The requested resource could not be found',
        408:'Request Timeout',
        502:'Bad Gateway'
    },
    transferFilesCB:null,
    successFileCB:null,
    transferFilesSuccessIndex:0,
    transferFilesCount:0,
    transferFailCount:0,
    tmpPathArr:[],
    tmpFilesArr:[],
    tmpAbsBaseUrl:null,
    transfertOptions:null,

    setApplicationRoot:function(path) {
        this.applicationRoot = path;
    },

    getUrl:function () {
        this.initApplicationRoot();
        return this.applicationRoot + "www/";
    },

    initApplicationRoot:function () {
        //this.applicationRoot = window.NativeCore.getFilesDir();
    },

    init:function (succesCB) {
        //console.log('FS.init()');
        this.initApplicationRoot();
        transfertOptions = {
            chunkedMode:true
        }
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {

            var fs = FS;
            fs.root = fileSystem.root;
            succesCB(fileSystem);
        }, function (e) {
            //console.log('heh he');
        });
    },
    transferFiles:function (absBaseUrl, files, successAllCB, successFileCB) {
        this.transferFilesCount = files.length;
        if (!this.transferFilesCount)
            return successAllCB();

        this.tmpFilesArr = files;
        this.tmpAbsBaseUrl = absBaseUrl;
        this.transferFilesCB = successAllCB;
        this.successFileCB = successFileCB;

        var fileRelPath = files.pop();
        var fileURI = absBaseUrl + fileRelPath;

        if (fileRelPath)
            this.transfer(fileURI, this.applicationRoot + 'www/' + fileRelPath, this.transferFilesSuccess, this.transferFaileFail);

    },
    transferFilesSuccess:function (fileEntry) {
        var fs = FS;
        fs.transferFilesSuccessIndex++;
        fs.successFileCB(fileEntry, (fs.transferFilesSuccessIndex / fs.transferFilesCount) * 100);

        var tmpFilesArr = fs.tmpFilesArr;

        //console.log(fs.transferFilesSuccessIndex + ' Download Success!');
        //console.log(tmpFilesArr.length);

        var fileRelPath = tmpFilesArr.pop();
        //console.log(tmpFilesArr.length);

        var fileURI = fs.tmpAbsBaseUrl + fileRelPath;
        if (fileRelPath) {
            fs.transfer(fileURI, fs.applicationRoot + 'www/' + fileRelPath, fs.transferFilesSuccess, fs.transferFaileFail);
        } else {
            fs.transferFilesCB(fileEntry, fs.transferFailCount);
        }
    },
    transferFaileFail:function (error) {
        var fs = FS;
        navigator.notification.confirm('Transfer File Failed!', function (index) {
            var fs = FS;
            var tmpFilesArr = fs.tmpFilesArr;
            var fileRelPath;
            var fileURI;
            if (index == 1) {
                fileURI = error.source;
                fileRelPath = tmpFilesArr[tmpFilesArr.length - 1];
            } else {
                fileRelPath = tmpFilesArr.pop();
                fileURI = fs.tmpAbsBaseUrl + fileRelPath;
                fs.transferFailCount++;
            }
            if (fileRelPath) {
                fs.transfer(fileURI, this.applicationRoot + 'www/' + fileRelPath, fs.transferFilesSuccess, fs.transferFaileFail);
            }
        }, fs.httpErrors[error.http_status], 'Retry, Skip');
    },
    transfer:function (fromUrl, toPath, successCB, failCB) {
        this.getFile(this.root, toPath, function (file) {
            var options = new FileUploadOptions();
            options.chunkedMode = false;
            var fileTransfer = new FileTransfer();

            fileTransfer.download(
                encodeURI(fromUrl),
                file.fullPath,
/*                function(entry) {
                        console.log("download complete: " + entry.fullPath);
                    },
                    function(error) {
                        console.log("download error source " + error.source);
                        console.log("download error target " + error.target);
                        console.log("upload error code" + error.code);
                    },
*/
                successCB,
                failCB,
                true
            );
        });
    },
    write:function (file, to, successCB, failCB) {

    },
    read:function (onentry, path, successCB, failCB, asDataurl) {

    },
    getFile:function (onentry, path, successCB) {
        var pathArr = path.split('/').reverse();
        this.tmpPathArr = pathArr;
        this.getFileCB = successCB;
        var dir = '';

        while (!dir) {
            dir = pathArr.pop();
        }

        onentry.getDirectory(dir, {create:true, exclusive:false}, this.dirSuccess);
    },
    dirSuccess:function (dir) {
        //console.log(dir.name + '/');
        var fs = FS;
        var tmpPathArr = fs.tmpPathArr;
        var dirName = tmpPathArr.pop();
        if (dirName) {
            if (dirName.split('.').length == 1)
                dir.getDirectory(dirName, {create:true, exclusive:false}, fs.dirSuccess, fs.entryFail);
            else
                dir.getFile(dirName, {create:true}, fs.fileSuccess, fs.entryFail);
        }
//    else if('function' == typeof fs.getFileCB)
//      fs.getDirCB(file);

    },
    entryFail:function (e) {
        //console.log('Entry Create Error!');
        //console.log(e);
    },
    fileSuccess:function (file) {
        var fs = FS;
        if ('function' == typeof fs.getFileCB)
            fs.getFileCB(file);
    }
}
