/*
 * jQuery Mobile Framework : temporary extension to port jQuery UI's datepicker for mobile
 * Copyright (c) jQuery Project
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 */
(function ($, undefined) {

  //cache previous datepicker ui method
  var prevDp = $.fn.datepicker;

  //rewrite datepicker
  $.fn.datepicker = function (options) {

    var dp = this;

    //call cached datepicker plugin
    prevDp.call(this, options);
    dp;

    //extend with some dom manipulation to update the markup for jQM
    //call immediately
    function updateDatepicker(event) {
      $(".ui-datepicker-header", dp).addClass("ui-body-c ui-corner-top").removeClass("ui-corner-all");
      $(".ui-datepicker-prev, .ui-datepicker-next", dp).attr("href", "#");
      $(".ui-datepicker-prev", dp).buttonMarkup({iconpos:"notext", icon:"arrow-l", shadow:true, corners:true});
      $(".ui-datepicker-next", dp).buttonMarkup({iconpos:"notext", icon:"arrow-r", shadow:true, corners:true});
      $(".ui-datepicker-calendar th", dp).addClass("ui-bar-c");
      $(".ui-datepicker-calendar td", dp).addClass("ui-body-c");
      $(".ui-datepicker-calendar a", dp).buttonMarkup({corners:false, shadow:false});
      $(".ui-datepicker-calendar a.ui-state-active", dp).addClass("ui-btn-active"); // selected date
      $(".ui-datepicker-calendar a.ui-state-highlight", dp).addClass("ui-btn-up-e"); // today"s date
      $(".ui-datepicker-calendar .ui-btn", dp).each(function () {
        var el = $(this);
        // remove extra button markup - necessary for date value to be interpreted correctly
        // todo Apptouch Mod {
        if (el.find(".ui-btn-text").text()) {
          el.html(el.find(".ui-btn-text").text());
        }
      });
      if (event && ($(event.target).closest('.ui-btn').length > 0 || $(event.target).hasClass('ui-btn')) && $(event.target).closest('td').length > 0) {
        dp.closest('.ui-dialog').dialog('close');
        setTimeout(function () {
          $(".component-form input[type='date'], input:jqmData(type='date')").change(); // todo shit code!
        }, 100);
      }
      ;
      // todo } Apptouch Mod

    }

    ;

    //update now
    updateDatepicker();

    // and on click
    $(dp).click(updateDatepicker);

    //return jqm obj
    return this;
  };

  //bind to pagecreate to automatically enhance date inputs
  $(".ui-page").live("pagecreate", function () {
    $("input[type='date'], input:jqmData(type='date')", this).each(function () {
      // todo Apptouch Mod {

      var $this = $(this);
      var oldVal = $this.val();

      var $dp = $("<div />").datepicker({ dateFormat:core.locale.format('date'), altField:"#" + $this.attr("id"), showOtherMonths:true });
      if (oldVal) {
        $dp.datepicker('setDate', new Date(oldVal));
      }
      var dialog_id = 'apptouch_local_' + $dp.attr('id');
      var $dialog = UIComponent.layout.$createBase('dialog', {'id':dialog_id});
      var $button = $("<a />").text(oldVal ? new Date(oldVal).toDateString() : new Date($this.val()).toDateString()).attr({'href':'#' + dialog_id, 'data-icon':'calendar'}).button();

      $this.after($button);
      $this.bind('change', function () {
        $button.find('span.ui-btn-text').html(new Date($this.val()).toDateString());
      })
//      $dialog.children("div:jqmData(role='header')").remove();
      $dialog.children("div:jqmData(role='content')").append($("<div />").datepicker({dateFormat:core.locale.format('date'), altField:"#" + $this.attr("id"), showOtherMonths:true }));

      if (oldVal) {
        $this.val(oldVal);
      }
      // todo } Apptouch Mod
    });
  });
})(jQuery);