window.phonegap = {
  host: {
    basehref: null, // todo to change
    theme: 'default'
  },
  options: {
    configRequestUrl: 'appmanager/phonegap/',
    dashboardUrl: '/board/'
  },
  pg_config: {
    url: null,
    hostUrl: null
  },

  init: function () {
    window.stepBackOnAir = false;
    window.NativeCore.showLoader();

    this.initPGConfig();
    this.settings._init();
    try {
      //this.lazyCommit._init();
      this.offlineManager._init();
    } catch (e) {
      console.log(e + ' <======= 2');
    }
//        this._setup();
    this._bindEvents();
    this.getConfigurations();
  },

  initPGConfig: function () {
    var self = this;
    if (window.default_settings) {
      var settings = default_settings.settings;
      self.pg_config.url = settings.siteinfo.basehref;
    } else {
      self.pg_config.url = localStorage.getItem('basehref');
    }
  },

  registerDevice: function (reg_id) {
    $.ajax({
      url: self.pg_config.url + this.options.configRequestUrl,
      timeout: 20000,
      method: 'post',
      data: {
        'gcmRegId': reg_id
      },
      success: function (data) {
      },
      error: function (e) {
      }
    });
  },

  _setup: function () {

    var siteinfo = this.settings.get('siteinfo');
    var $head = $(document.head);
//    Set Base Reference
    var themeName = 'default';
//    Setup Theme
    if (siteinfo && siteinfo['theme']) {
      themeName = siteinfo['theme'];
    }
    $head.prepend($(document.createElement('link')).attr({
      href: ['themes/', themeName, '/theme.css'].join(''),
      media: 'screen',
      rel: 'stylesheet',
      type: 'text/css'
    }));
    $head.prepend($(document.createElement('link')).attr({
      href: ['tablet/themes/', themeName, '/theme.css'].join(''),
      media: 'screen',
      rel: 'stylesheet',
      type: 'text/css'
    }));

    $head[0].getElementsByTagName('base')[0].setAttribute('href', this.pg_config.url);
    if (!siteinfo)
      return;
//    Configure Start Page
    if (siteinfo['title']) {
      var $startpage = $(document.getElementById('initial_page'));
      $startpage[0].getElementsByClassName('site-title')[0].innerHTML = siteinfo['title'];
      $startpage[0].getElementsByClassName('site-description')[0].innerHTML = siteinfo['description'];
      $startpage[0].getElementsByClassName('site-copyright')[0].innerHTML = (siteinfo['copyrightString']);
      $startpage[0].getElementsByClassName('site-logo')[0].setAttribute('src', siteinfo['logo']);
      delete $startpage;
    }
    delete siteinfo;
  },

  getConfigurations: function () {
    var self = this;
    window.NativeCore.showLoader();
    var templatesExists = localStorage.getItem('templatesExists');
    if (!templatesExists) {
      //var templates = window.NativeCore.getTemplates();
      localStorage.setItem('templatesExists', true);
    }
    window.NativeCore.hideLoader();
//    $.mobile.showPageLoadingMsg();
    //if (localStorage.getItem('mode') == 'offline') {
    if (phonegap.offlineManager.isOffline()) {
      /*if (window.default_settings)
       phonegap.offlineManager.__setOffline(true);*/
      $(document).trigger('pgconfigload', default_settings);
    } else {
      $.ajax({
        type: 'post',
        url: self.pg_config.url + this.options.configRequestUrl,
        timeout: 20000,
        data: self._getPostData(),
        success: function (data) {
          $(document).trigger('pgconfigload', data);
        },
        error: function (e) {
          $(document).trigger('pgconfigloaderror', e);
        }
      });
    }
  },

  _bindEvents: function () {
    var self = this;
    $(document).unbind('pgconfigload').bind('pgconfigload', function (event, data) {
      $.mobile.hidePageLoadingMsg();
      this.config = data;

      $.mobile.urlHistory.stack = [0];
      $.mobile.urlHistory.activeIndex = 1;

      var theme = data.settings.siteinfo.theme;
      if (!phonegap.offlineManager.isOffline()) {
        phonegap.offlineManager.setPageData("theme", theme);
      } else {
        theme = phonegap.offlineManager.getPageData("theme");
      }
      window.NativeCore.setTheme(theme);

      self._setupConfigs(data);
    });
    $(document).unbind('pgconfigloaderror').bind('pgconfigloaderror', function (event, data) {
      console.log('pgconfigloaderror handled');
      $.mobile.hidePageLoadingMsg();
      $.mobile.changePage($('#timeout-error'));
      // todo handle error;
    });
    $(document).unbind('pgconfigready').bind('pgconfigready', function (event, data) {
      if (data.templates) {
        self._applyTemplates(data.templates);
      }
      core.setBaseUrl(data.siteinfo.baseUrl);
      core.construct(this.config);
      window.NativeCore.splashScreen(false);
    });
    $(document).bind("pagebeforechange", function (e, jQPageData) {
      if ('string' == typeof jQPageData.toPage && jQPageData.toPage.indexOf('.html') == -1) { // todo shit code
        if (renderer.helper.isUrlValid(jQPageData.toPage)) {
          self.settings.states['return_url'] = jQPageData.toPage.replace('file://', '');
          self.settings._saveStates();
        }
      }
    });

    $(document).bind("pagedatasuccess", function (e, data) {
      if (data.jQPageData.options.type.toLowerCase() == 'get') {
        phonegap.offlineManager.setPageData(data.jQPageData.dataUrl, data.responseString);
      }
    });
    $(document).ajaxSuccess(function (event, XMLHttpRequest, ajaxOptions) {
      console.log("ajax success");
      window.stepBackOnAir = false;
      phonegap.offlineManager.__setOffline(false);
    });
    $(document).ajaxError(function (event, jqxhr, settings, exception) {
      console.log("ajax error");
      window.stepBackOnAir = false;
      phonegap.offlineManager.__setOffline(true);
      /*if (settings.type.toLowerCase() == 'post') {

       phonegap.lazyCommit.addToJobQueue(settings);
       }*/
    });
  },

  _setupConfigs: function (response) {
    if (response.settings && 'object' == typeof response.settings) {
      this.settings._store(response.settings);
    }
  },

  _applyTemplates: function (templates) {
    try {
      console.log("flag templates len " + templates.length);
      for (var i = 0; i < templates.length; i++) {

      }
      $(document.body).append($(templates));
    } catch (e) {
      console.log(e);
    }
  },

  _applySettings: function (settings) {

  },

  tmpGcmReg: '',
  _getPostData: function () {

    this.settings._loadStates();
    var postData = {};
    for (var key in this.settings.states) {
      postData[key] = this.settings.states[key];
    }
    postData["gcmRegId"] = localStorage.getItem('gcmRegId');
    postData['format'] = 'json';
    return postData;
  },

  _constructLocationProto: function (location) {
//    Init Prototype
    for (var key in this.locationProto) {
      var prop = location[key];
      if ('string' == typeof prop) {
        this.locationProto[key] = location[key];
      }
    }
    this.locationProto = location;

    // Define Setters
    try {
      this.locationProto.__defineSetter__('href', function (value) {
        $(document).data('clearCache', 1);
        var parsedUrl = $.mobile.path.parseUrl(value);
        if (this.hostname == parsedUrl.hostname) {
          $.mobile.changePage(parsedUrl.pathname);
          return value;
        } else {
          window.open(value);
        }

      });
      this.locationProto.__defineSetter__('pathname', function (value) {
        if (value.indexOf('/') != 0) {
          value = '/' + value;
        }
        this.href = [this.protocol, '//', this.host, value, "#", this.hash].join('');
        return value;
      });
      this.locationProto.__defineSetter__('hash', function (value) {
        if (value.indexOf('#') != 0) {
          value = '#' + value;
        }
        $.mobile.changePage(value);
        return value;
      });
    } catch (e) {
      console.log(e + '');
    }
    core.location = this.locationProto;
  },

  fileUploader: function ($fileElement) {
    this.uploader.open($fileElement);
  },

  _setStartPage: function (url) {
    var s = this.settings;
    s._init();
    s.states['return_url'] = url;
    s._saveStates();
  },

  lazyCommit: {
    jobKeyPref: '_LCJob',
    jobTimestampsKey: '_LCJobIndexes_',
    intervalId: 0,
    interval: 5000,
    lastJobContentLength: 0,
    connectionCheckUrl: '',
    connectionCheckTimeout: 500,
    timestamps: null,
    _bisy: false,
    _init: function () {
      this._loadJobQueue();
      this.commit();
      console.log('phonegap.lazyCommit._init()');
    },
    _loadJobQueue: function () {
      var timestamps = localStorage.getItem(this.jobTimestampsKey);

      this.timestamps = timestamps ? $.parseJSON(timestamps) : [];

      this.timestamps.sort();
      return this.timestamps;
      console.log('phonegap.lazyCommit._loadJobQueue()');
    },
    addToJobQueue: function (ajaxSettings) {
      if (this.lastJobContentLength == ajaxSettings.data.length || (ajaxSettings.data.search('submit') == -1 && 8 == (this.lastJobContentLength - ajaxSettings.data.length))) {
//                UIComponent.helper.showMessage(core.lang.get('No changes has made!'));
        return;
      }
      alert(core.lang.get('APPTOUCH_There are some troubles with Internet connection'));
//            alert(core.lang.get('APPTOUCH_Your post will be posted as soon as the connection resumes'));
      $.mobile.hidePageLoadingMsg();
      var self = this;
      setTimeout(function () {
        var timestamp = new Date().getTime();// - 3600000;
        self.lastJobContentLength = ajaxSettings.data.length;

        var data = ajaxSettings.data;

        var job = {
          url: ajaxSettings.url,
          data: data,
          type: ajaxSettings.type,
          dataType: ajaxSettings.dataType,
          timestamp: timestamp
        };
        var timestampsKey = self.jobTimestampsKey;
        var jobKey = self._getJobKey(timestamp);
        self.timestamps.push(timestamp);
        localStorage.setItem(timestampsKey, JSON.stringify(self.timestamps));
        localStorage.setItem(jobKey, JSON.stringify(job));
      }, 0);
      console.log('phonegap.lazyCommit.addToJobQueue()');
    },
    getJobFromQueue: function () {
      var job = localStorage.getItem(this._getJobKey(this.timestamps[0]));
      if (job)
        job = $.parseJSON(job);
      console.log('phonegap.lazyCommit.getJobFromQueue()');
      return job;
    },
    _deleteJobFromQueue: function () {
      var key = this.timestamps[0];

      localStorage.removeItem(this._getJobKey(key));
      delete this.timestamps[0];
      this.timestamps.sort();
      this.timestamps.pop();

      localStorage.setItem(this.jobTimestampsKey, JSON.stringify(this.timestamps));
      console.log('phonegap.lazyCommit._deleteJobFromQueue()');
    },
    _doJob: function () {
      console.log('phonegap.lazyCommit._doJob()');
      var job = this.getJobFromQueue();
      if (!job) {
        clearInterval(this.intervalId);
//        UIComponent.helper.showMessage(core.lang.get('APPTOUCH_Lazy Commit Complete!'), 'b', 5000);
        return;
      }
      console.log(job);
      console.log('lazy');
      if (!job.url.length) {
//            alert(job.url.length);
        this._deleteJobFromQueue();
        this._bisy = false;
        return;
      } //else alert(job.url);
      if (this._bisy)
        return;
      this._bisy = true;

      var lag = new Date().getTime() - job.timestamp;
      if (lag > 216E+5) {
        lag = 0;
      }
      delete job.timestamp;


      job.data = job.data ? [job.data, '&lazy-commit', '=', lag].join('') : {'lazy-commit': lag};
      var self = this;
      job.success = function (response) {
        console.log('_doJob Success!');
        if (!response.error) {
          self._deleteJobFromQueue();
        }
        self._bisy = false;
        console.log('_doJob Success!');
        console.log(arguments);
      };
      job.error = function () {
        console.log('_doJob Error!');
        self._bisy = false;
        console.log('_doJob Error!');
        console.log(arguments);
      };
      $.ajax(job);
    },
    commit: function () {
      var hasJobs = this.getJobFromQueue();
      hasJobs = hasJobs && ('object' == typeof hasJobs);
      if (this._checkConnection() && hasJobs) {
//                UIComponent.helper.showMessage(core.lang.get('APPTOUCH_Lazy Commit Starts!'), 'b', 3000);
        var self = this;
        this.intervalId = setInterval(function () {
          console.log('bisy = ' + self._bisy);
//                     if (self._bisy)
//                        return;
          self._doJob();
        }, this.interval);
        console.log('phonegap.lazyCommit.commit() starts');
      }
    },
    _getJobKey: function (timestamp) {
      return [this.jobKeyPref, timestamp].join('_');
    },
    _checkConnection: function (timeout) {
      console.log('phonegap.lazyCommit._checkConnection() starts');
      return true;
//      if(navigator.connection.type == Connection.NONE){
//        return false;
//      }
    }
  },

  offlineManager: {
    _keyPref: '_OMPD',
    _keyPrefByTimestamp: '_OMPDBT',
    _keyPrefTimestamp: '_OMPD_Timestamps',
    _isOffline: false,
    _lifetime: 6048E+5,
    _timestamps: [],
    _init: function () {
      this.__setOffline(/*window.NativeCore.isOffline()*/);
      this._cleanUp();
    },
    _cleanUp: function () {
      if (this._isOffline)
        return;
      this._loadTimestamps();
      var timestamps = this._timestamps;
      if (!timestamps.length)
        return;
      var time = this._timestamps[0].timestamp;
      var now = new Date().getTime();
      var key = this._timestamps[0].pageKey;
      var ls = localStorage;
      timestamps.reverse();
      while ((now - time) > 6048E+5 && key) {
        ls.removeItem(key);
        timestamps.pop();
        var lastEl = timestamps[timestamps.length - 1];
        time = lastEl.timestamp;
        key = lastEl.pageKey;
      }
      timestamps.reverse();
      this._saveTimestamps();
    },
    _loadTimestamps: function () {
      var timestamps = $.parseJSON(localStorage.getItem(this._keyPrefTimestamp));
      if (timestamps)
        this._timestamps = timestamps;
      return this._timestamps;
    },
    _saveTimestamps: function () {
      var self = this;
      setTimeout(function () {
        var ls = localStorage;
        ls.setItem(self._keyPrefTimestamp, JSON.stringify(self._timestamps));
      }, 100);
    },

    isOffline: function () {
      return this._isOffline;
    },

    __setOffline: function (isOffline) {
      if (this._isOffline == isOffline)
        return;

      this._isOffline = isOffline;
      if (isOffline) {
        $(document.body).addClass('offline');
      } else {
        var c = core.cache;
        c.clear('#core_dashboard_index_rewrite');
        //var lc = phonegap.lazyCommit;
        var body = document.body;
        //lc.commit();
        $(body).removeClass('offline');
      }
    },

    setPageData: function (pageUrl, data) {
      var key = this._getPageKey(pageUrl);
      var oldData = localStorage.getItem(key);
      var self = this;
      if (!oldData || oldData.length != data.length)
        setTimeout(function () {
          var timestamps = self._timestamps;
          timestamps.push({timestamp: new Date().getTime(), pageKey: key});
          self._saveTimestamps();
          localStorage.setItem(key, data);
        }, 0);
    },

    getPageData: function (pageUrl) {
      var key = this._getPageKey(pageUrl);
      return localStorage.getItem(key);
    },

    remove: function (pageUrl) {
      var pageKey = this._getPageKey(pageUrl);
      var item = localStorage.getItem(pageKey);
      localStorage.removeItem(this._getPageKey(pageUrl));
      return item;
    },

    clearAll: function () {

    },

    _getPageKey: function (pageUrl) {
      return [this._keyPref, pageUrl].join('_');
    }
  },

  config: null,

  settings: {
    options: {
      configKey: 'pgConfig',
      configStatesKey: 'configStates'
    },

    states: {
      locale: 0,
      siteinfo: 0,
      location: 0,
      templates: 0
    },

    _values: {},

    _init: function (data) {
      if (data)
        this._update(data);
      this._loadFromStorage();
    },

    _loadFromStorage: function () {
      var settingsJsonObj = localStorage.getItem(this.options.configKey);
      //alert("Here");
      if (settingsJsonObj && 'string' == typeof settingsJsonObj)
        try {
          this._loadStates();
          this._update($.parseJSON(settingsJsonObj));
        } catch (e) {
          console.warn('_loadFromStorage');
          console.warn(e);
        }
    },

    _update: function (data) {

      for (var key in data) {
        if (key == 'states') continue; // continue if it is "states"
        this._values[key] = data[key];
      }
      this._updateStates(data.states);
      this._save();
    },

    get: function (name) {
      if (name)
        return this._values[name];
      else
        return this._values;
    },

    set: function (name, val) {
      this._values[name] = val;
      this._updateState(name);
      this._save();
    },

    _save: function () {
      try {
        localStorage.setItem(this.options.configKey, JSON.stringify(this._values));
        this._saveStates();
      } catch (e) {
        console.warn('_save');
        console.warn(e);
      }
    },

    _saveStates: function () {
      try {
        localStorage.setItem(this.options.configStatesKey, JSON.stringify(this.states));
      } catch (e) {
        console.warn('_saveStates');
        console.warn(e);
      }
    },

    _updateState: function (name) {
      this.states[name] = JSON.stringify(this._values[name]).length;
    },

    _getState: function (name) {
      return this.states[name];
    },

    _updateStates: function (states) {
      for (var key in states) {
        this.states[key] = states[key];
      }
    },

    _loadStates: function () {
      var statesJsonObj = localStorage.getItem(this.options.configStatesKey);
      if (statesJsonObj)
        try {
          this.states = $.parseJSON(statesJsonObj)
        } catch (e) {
          console.warn('_loadStates');
          console.warn(e);
        }
    },

    _store: function (data) {
      /*var self = this;
       core.lang.add(data.langs);
       this._update(data);
       $(document).trigger('pgconfigready', this._values)
       return; // todo LocalFileSystem ???*/
      try {
        var self = this;
        core.lang.add(data.langs);
        this._update(data);

        var templatesPath = "/data/data/it.lesbook.lesbookApp/files/www/res";

        var gotFileEntry = function (fileEntry) {
          fileEntry.file(gotFile, fail);
        }

        function fail(e) {
          console.log("FileSystem Error");
          console.dir(e);
        }

        function gotFile(fileEntry) {

          fileEntry.file(function (file) {
            var reader = new FileReader();

            reader.onloadend = function (e) {
              phonegap._setup();
              self._values.templates = e.target.result;
              $(document).trigger('pgconfigready', self._values);
            }
            reader.readAsText(file);
          });

        }

        window.resolveLocalFileSystemURL(cordova.file.applicationStorageDirectory + "files/www/res/templates.html", gotFile, fail);
      } catch (e) {
        console.warn('_store');
        console.warn(e);
      }
    }
  },

  locationProto: {
    _proto_: {},
    hash: '',
    host: '',
    hostname: '',
    href: '',
    pathname: '',
    port: '',
    protocol: 'http:',
    search: '',
    _getter: function (name) {
      this._proto_[name];
    }
  },

  uploader: {
    options: {
      $input: null, // defined  by open
      $form: null, // defined  by open
      multiUpload: false
    },
    _fileMimeTypes: {

      //          Type image
      'jpg': 'image/jpeg',
      'jpeg': 'image/jpeg',
      'gif': 'image/gif',
      'png': 'image/png',
      'tiff': 'image/tiff',
      'svg': 'image/svg+xml',
      'ico': 'image/vnd.microsoft.icon',
      'jfif': 'image/pjpeg',

      //          Type audio
      'mp3': 'audio/mpeg',
      'ogg': 'audio/ogg',
      'oga': 'audio/vorbis',
      'wav': 'audio/vnd.wave',
      'au': 'audio/L24',
      'ra': 'audio/vnd.rn-realaudio',

      //           Type video
      'flv': 'video/x-flv',
      'qt': 'video/quicktime',
      'mov': 'video/quicktime',
      'mp4': 'video/mp4',
      'mpg': 'video/mpeg',
      'webm': 'video/webm',
      'wmv': 'video/x-ms-wmv',
      'ogv': 'video/ogg',
      'mpeg': 'video/mpeg',
      'mkv': 'video/x-matroska',

      //           Type application
      'pdf': 'application/pdf',
      'zip': 'application/zip',
      'gzip': 'application/gzip',

      //          Type text
      'txt': 'text/plain',
      'html': 'text/html',
      'htm': 'text/html',
      'xml': 'text/xml',
      'css': 'text/css'

    },
    destinations: null, // defined  by setup
    sources: null, // defined  by setup
    uploadUrl: null, // defined  by setup
    fileUploadOptions: null, // defined  by setup
    uploadRelativeUrl: "/apptouch/picup/",

    uploadStats: {
      toProceed: 0,
      success: 0,
      fail: 0
    },
    response: [],
    cont_type: '',

    open: function ($fileInput) {
      this._setup($fileInput);

      var type = 'image';
      var amountType = false;

      if ($fileInput.attr('accept')) {
        type = $fileInput.attr('accept').split('/')[0];
      }

      var name = $fileInput.attr('name');
      if (name && name.indexOf('[]', name.length - 2) !== -1) {
        amountType = true;
      }

      window.NativeCore.showUploader(type, amountType);
    },

    _setup: function ($fileinput) {
      this.options.$input = $fileinput;
      this.options.$form = $fileinput.closest('form');
      this.options.multiUpload = $fileinput.attr('name').indexOf('[]') > -1;
      this.destinations = navigator.camera.DestinationType;
      this.sources = navigator.camera.PictureSourceType;
      //this.uploadUrl = encodeURI(phonegap.host.basehref + this.uploadRelativeUrl);
      this.uploadUrl = encodeURI(phonegap.pg_config.url + this.uploadRelativeUrl);
    },

    _addFile: function (mediaURI) {
      var self = this;
      var $ftu = this.$ftu;

      // prepare File item
      var $file = $ftu.find('.fileTpl.to-upload').clone().removeClass('fileTpl');
      var filename = $.mobile.path.parseUrl(mediaURI).filename;
      $file.data('file', mediaURI);
      $file.data('filename', filename);
      var $img = $file.find('.file-item img').clone().attr('src', mediaURI);
      $file.find('.file-item').html(filename);
      $file.find('.file-item').prepend($img);

      if (this.options.multiUpload) {
        // binding events
        $file.find('.delete-file').click(function (e) {
          self._removeFile($(this).closest('li'));
        });
      } else {
        $ftu.find('.file').not('.fileTpl').remove();
        $file.find('.delete-file').remove();
      }

      $ftu.append($file);
      $ftu.find('.file-count').find('.ui-li-count').html($ftu.find('.file').not('.fileTpl').length);
      this.$fus.find('.no-files').show();
    },

    _removeFile: function ($elem) {
      var $ftu = this.$ftu;
      $elem.remove();
      var fileCount = $ftu.find('.file').not('.fileTpl').length;
      $ftu.find('.file-count').find('.ui-li-count').html(fileCount);
      if (!fileCount)
        this.$fus.find('.no-files').hide();

    },

    _uploadFiles: function (files, type) {
      this.cont_type = type;
      files = files.split(',');
      this.uploadStats.toProceed = files.length;
      this.uploadStats.success = 0;
      this.uploadStats.fail = 0;
      this.response = [];
      for (var index = 0; index < files.length; index++) {
        var file = files[index];
        var filename = $.mobile.path.parseUrl(file).filename;
        var options = this._prepareUploadOptions(filename);
        this._transferFile(file, options);
      }
    },

    _prepareUploadOptions: function (filename) {
      var options = new FileUploadOptions();
      var inputName = this.options.$input.attr('name').replace(core.picup.pref, '');
      options.fileKey = inputName.replace('[]', '');
      options.fileName = filename;
      options.mimeType = this.getFileMimeType(filename);
      var params = new Object();
      params.format = "json";
      params.input = inputName;
      options.params = params;
      return options;
    },

    getFileExtension: function (filename) {
      var re = /(?:\.([^.]+))?$/;
      return re.exec(filename)[1] == undefined ? "" : re.exec(filename)[1];
    },

    getFileMimeType: function (fileNameString) {
      var fileExt = this.getFileExtension(fileNameString);
      fileExt = !fileExt ? 'txt' : fileExt;
      var mime = this._fileMimeTypes[fileExt];
      return mime;
    },

    _transferFile: function (file, options) {
      var self = this;
      //      var file = $file.data('file');
      var ft = new FileTransfer();
      ft.upload(file, this.uploadUrl,
        function (serverResponse) { // Success!
          self._fileTransferSuccess(serverResponse);
          self._checkComplete();
        },
        function (error) { // Fail!
          self._fileTransferFail(error, file);
          self._checkComplete();
        }, options);
    },

    _fileTransferSuccess: function (serverResponse) {
      this.uploadStats.success++;
      this.response.push($.parseJSON(serverResponse.response).response);
    },

    _fileTransferFail: function (error, $file) {
      this.uploadStats.fail = 0;
      console.log("An error has occurred: Code = " + error.code);
      console.log("upload error source " + error.source);
      console.log("upload error target " + error.target);

    },

    _checkComplete: function () {
      var toProceed = this.uploadStats.toProceed;
      var success = this.uploadStats.success;
      var fail = this.uploadStats.fail;
      if ((success + fail) == toProceed) {
        //        var response = [];
        //        var $files = this.$pf.children('.success');
        //        try {
        //            for (var i = 0; i < $files.length; i++) {
        //                var $file = $($files[i]);
        //
        //                response.push($.parseJSON($file.data('serverResponse').response).response);
        //            }
        //        } catch (e) {
        //            console.log(e + '');
        //        }
        var data = {
          succeeded: success,
          fails: fail,
          response: this.response
        };
        this._uploadComplete(data)
      }
    },

    _uploadComplete: function (result) {
      if (result.fails == 0) {
        //                this.$fus.dialog('close');
        this.options.$form.data('picup').handleUploadResponse(this.options.$input, result.response);
        console.log('uploader success type - ' + this.cont_type);
        if (this.cont_type == 'video') {
          $('#upload-wrapper').show();
        }
      }
    },

    _addToProceeded: function ($file) {
      var $pf = this.$pf;
      var status = $file.data('status');

      // prepare File item
      if (status == 'success') {
        $pf.append($file);
        $pf.find('.file-count').find('.ui-li-count').html($pf.children('.success').length);
        $pf.show();
      }
      this._removeFile($file.clone()); // fool this method! ;)
    },

    _addToFailed: function ($file) {
      var $ff = this.$ff;
      var status = $file.data('status');

      // prepare File item
      if (status == 'fail') {
        $ff.append($file);
        $ff.find('.file-count').find('.ui-li-count').html($ff.children('.fail').length);
        $ff.listview('refresh').show();
      }
      this._removeFile($file.clone()); // fool this method! ;)
    }
  }

};
